//------------------------------------------------------------------
#property  copyright "mladen"
#property  link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property  indicator_separate_window
#property  indicator_buffers 4
#property indicator_color1   ForestGreen
#property indicator_color2   OrangeRed
#property indicator_color3   OrangeRed
#property indicator_color4   DarkGray
#property indicator_style4   STYLE_DOT
#property indicator_width1   2
#property indicator_width2   2
#property indicator_width3   2

//
//
//
//
//

extern int                PFEPeriod = 14;
extern ENUM_APPLIED_PRICE PFEPrice  = PRICE_CLOSE;
extern int                Smooth    = 10;

double buffer1[];
double buffer2[];
double pfeda[];
double pfedb[];
double slope[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   IndicatorDigits(0);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,pfeda);
   SetIndexBuffer(2,pfedb);
   SetIndexBuffer(3,buffer2); SetIndexLabel(3,NULL);
   SetIndexBuffer(4,slope);
   IndicatorShortName("Polarized fractal efficiency Erkhardt ("+PFEPeriod+","+Smooth+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double mom[];
double div[];
double inp[];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArraySize(mom)!=Bars) ArrayResize(mom,Bars);
           if (ArraySize(div)!=Bars) ArrayResize(div,Bars);
           if (ArraySize(inp)!=Bars) ArrayResize(inp,Bars);

   //
   //
   //
   //
   //
   
   double alpha = 2.0/(1.0+Smooth);
   if (slope[limit]==-1) CleanPoint(limit,pfeda,pfedb);
   for(i = limit,r=Bars-i-1; i >= 0; i--,r++)
   {
      inp[r] = iMA(NULL,0,1,0,MODE_SMA,PFEPrice,i);

      if (i<Bars-1)
            mom[r] = MathAbs(inp[r]-inp[r-1]);
      else  mom[r] = 1;    
      if (i<Bars-1) 
            div[r] = mom[r]+div[r-1];
      else  div[r] = mom[r]; 
      if (i<=Bars-PFEPeriod) 
            div[r] -= mom[r-PFEPeriod];
      
      //
      //
      //
      //
      //
      
      buffer1[i] = buffer1[i+1]+alpha*((inp[r]-inp[r-PFEPeriod])/div[r]-buffer1[i+1]);
      buffer2[i] = 0;
      pfeda[i] = EMPTY_VALUE;
      pfedb[i] = EMPTY_VALUE;
      slope[i] = slope[i+1];
      if (buffer1[i]>buffer1[i+1]) slope[i] = 1;
      if (buffer1[i]<buffer1[i+1]) slope[i] =-1;
      if (slope[i]==-1) PlotPoint(i,pfeda,pfedb,buffer1);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
         if (first[i+2] == EMPTY_VALUE) 
              { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
         else { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else       { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}
